package com.marvinelsen.willow

import javafx.beans.property.IntegerProperty
import javafx.beans.property.SimpleIntegerProperty
import java.util.prefs.Preferences

class Config {
    companion object {
        private const val DETAIL_HEADWORD_FONT_SIZE_KEY = "detailHeadwordFontSize"

        private const val DEFAULT_DETAIL_HEADWORD_FONT_SIZE = 16
    }

    private val preferences = Preferences.userNodeForPackage(this::class.java)

    val detailHeadwordFontSize: IntegerProperty = SimpleIntegerProperty(DEFAULT_DETAIL_HEADWORD_FONT_SIZE)

    fun save() {
        preferences.putInt(DETAIL_HEADWORD_FONT_SIZE_KEY, detailHeadwordFontSize.value)
    }

    fun load() {
        detailHeadwordFontSize.value = preferences.getInt(
            DETAIL_HEADWORD_FONT_SIZE_KEY,
            DEFAULT_DETAIL_HEADWORD_FONT_SIZE
        )
    }

    fun reset() {
        detailHeadwordFontSize.value = DEFAULT_DETAIL_HEADWORD_FONT_SIZE
    }
}
